controllers/PedidoController.php
<?php

namespace app\controllers;

use app\models\Pedido;
use app\models\Producto;
use Yii;
use yii\data\ActiveDataProvider;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * PedidoController implements the CRUD actions for Pedido model.
 */
class PedidoController extends Controller
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                // acciones del controlador que voy a gestionar 
                'only' => ['*'],
                'rules' => [
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['@'], // @ indica que el usuario está logeado  
                    ],
                    [
                        'actions' => [''], // el usuario no logeado no puede hacer nada
                        'allow' => true,
                        'roles' => ['?'], // ? indica que el usuario no está logeado
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }


    /**
     * Lists all Pedido models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Pedido::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'idPedido' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Pedido model.
     * @param int $idPedido Id Pedido
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($idPedido)
    {
        return $this->render('view', [
            'model' => $this->findModel($idPedido),
        ]);
    }

    /**
     * Creates a new Pedido model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Pedido();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'idPedido' => $model->idPedido]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Pedido model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $idPedido Id Pedido
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($idPedido)
    {
        $model = $this->findModel($idPedido);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'idPedido' => $model->idPedido]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Pedido model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $idPedido Id Pedido
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($idPedido)
    {
        //$this->findModel($idPedido)->delete();ç

        $pedido = Pedido::findOne(['idPedido' => $idPedido]);

        $producto = Producto::findOne(['idProducto' => $pedido->idProducto]);

        // Si se elimina el pedido, se suma la cantidad del pedido al stock y se guarda en la BBDD
        $producto->unidadesStock += $pedido->cantidad;
        $producto->save();

        // Borramos el pedido
        $pedido->delete();


        return $this->redirect(['index']);
    }

    /**
     * Finds the Pedido model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $idPedido Id Pedido
     * @return Pedido the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($idPedido)
    {
        if (($model = Pedido::findOne(['idPedido' => $idPedido])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Cliente;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\Pedido;
use app\models\Producto;
use app\models\Seccion;
use app\models\Usuario;
use yii\data\ActiveDataProvider;
use yii\web\NotFoundHttpException;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {

        $secciones = Seccion::find()->all();


        return $this->render('index', [
            'secciones' => $secciones
        ]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    public function actionSecciones()
    {
        $secciones = Seccion::find()->all();

        return $this->render('secciones', [
            'secciones' => $secciones
        ]);
    }

    public function actionSeccion($id)
    {
        $productos = Producto::find()->where(['seccion' => $id])->andWhere(['destacado' => 1])->all();
        $secciones = Seccion::find()->all();

        return $this->render('seccion', [
            'productos' => $productos,
            'secciones' => $secciones
        ]);
    }


    public function actionProductos($id)
    {
        $datos = Producto::find()->where(['seccion' => $id])->all();

        $dato = Producto::find()->where(['seccion' => $id])->one();

        return $this->render("productos", [
            "datos" => $datos,
            "titulo" => "Productos de la sección: " . $dato->seccion0->nombre,

        ]);
    }

    public function actionVerproducto($idProducto)
    {
        $consulta = Producto::find()->where(['idProducto' => $idProducto]);

        $dato = $consulta->one();

        return $this->render('verproducto', [
            'dato' => $dato,
        ]);
    }

    public function actionOfertas()
    {
        $secciones = Seccion::find()->all();

        return $this->render('ofertasListview', [
            'secciones' => $secciones
        ]);
    }

    // Accion de registro
    public function actionRegistro()
    {
        $model = new Usuario();

        if (Yii::$app->request->isPost) {
            $postData = Yii::$app->request->post();

            $model->load($postData);

            if ($model->validate() && $model->save()) {

                return $this->redirect(['site/success']);
            }
        }

        return $this->render('registro', ['model' => $model]);
    }

    // Accion cuando el usuario se ha registrado correctamente
    public function actionSuccess()
    {
        return $this->render('success');
    }

    // Accion para hacer un pedido
    public function actionHacerpedido($idProducto, $idUsuario = 0)
    {
        // Si el usuario no esta logeado => que se logee
        if (Yii::$app->user->isGuest || $idUsuario == null) {
            return $this->redirect(['site/login']);
        }

        // Si es la primera vez que el usuario hace un pedido, tenemos que crear un registro en la tabla cliente

        $cliente = Cliente::findOne(['usuario' => $idUsuario]);
        if ($cliente  == null) {
            // return $this->redirect(['/site/crearcliente', 'idCliente' => $idUsuario]);
            $user = Usuario::findOne($idUsuario);
            $cliente = new Cliente();
            $cliente->idCliente = $user->id;
            $cliente->nombre = $user->nombre;
            $cliente->correo = $user->username;
            $cliente->usuario = $user->id;
            $cliente->save();
        }

        // Para hacer un pedido se necesita que el cliente tenga direccion y telefono
        if ($cliente->direccion == "" || $cliente->direccion == null || $cliente->telefono == "" || $cliente->telefono == "") {
            Yii::$app->session->setFlash('error', 'Necesitamos tu dirección y tu teléfono');
            return $this->redirect(['cuenta', 'idUsuario' => $cliente->usuario]);
        }

        // Creamos un modelo vacio para pedidos
        $model = new Pedido();
        $producto = Producto::findOne($idProducto);
        $cliente = Cliente::findOne($idUsuario);

        $model->idCliente = $cliente->idCliente;
        $model->idProducto = $producto->idProducto;

        if ($this->request->isPost) {
            // Comprobamos si la cantidad solicitada es menor o igual que las unidades que se tiene en stock
            if ($model->load($this->request->post()) && $model->save() && $model->cantidad <= $producto->unidadesStock) {

                // Si se hace el pedido, las unidades en stock se modifican
                $producto->unidadesStock -= $model->cantidad;
                $producto->save();

                return $this->redirect(['pedido', 'idCliente' => $cliente->idCliente]);
                // Si la cantidad supera las unidades en stock, se muestra un mensaje de error
            } else {
                Yii::$app->session->setFlash('error', 'No disponemos de tantas unidades. Tenemos ' . $producto->unidadesStock . ' unidades');
                $model->delete();
            }
        } else {
            $model->loadDefaultValues();
        }

        // cargamos el formulario para hacer un pedido
        return $this->render('hacerpedido', [
            'model' => $model,
            "cliente" => $cliente,
            "producto" => $producto,
        ]);
    }

    // Accion cuando el usuario ha realizado un pedido correctamente
    public function actionPedido($idCliente)
    {
        return $this->render('pedido', [
            'idCliente' => $idCliente
        ]);
    }

    public function actionVerpedidos($idCliente)
    {

        $dataProvider = new ActiveDataProvider([
            'query' => Pedido::find()->where(['idCliente' => $idCliente]),

            'pagination' => [
                'pageSize' => 10
            ],
            /*
            'sort' => [
                'defaultOrder' => [
                    'idPedido' => SORT_DESC,
                ]
            ],
            */

        ]);

        return $this->render('verpedidos', [
            'dataProvider' => $dataProvider
        ]);
    }

    public function actionCuenta($idUsuario)
    {
        // Si el usuario no esta logeado => que se logee
        if (Yii::$app->user->isGuest) {
            return $this->redirect(['site/login']);
        }

        // Si es la primera vez que el usuario hace un pedido, tenemos que crear un registro en la tabla cliente
        if ($cliente = Cliente::findOne(['idCliente' => $idUsuario]) == null) {
            // return $this->redirect(['/site/crearcliente', 'idCliente' => $idUsuario]);
            $user = Usuario::findOne($idUsuario);
            $cliente = new Cliente();
            $cliente->idCliente = $user->id;
            $cliente->nombre = $user->nombre;
            $cliente->correo = $user->username;
            $cliente->usuario = $user->id;
            $cliente->save();
        }

        $model = Cliente::findOne($idUsuario);

        return $this->render('cuenta', [
            "model" => $model,
        ]);
    }


    // ACTUALIZAR DATOS DEL USUARIO
    public function actionActualizarcuenta($idCliente)
    {
        // Si el usuario no esta logeado => que se logee
        if (Yii::$app->user->isGuest) {
            return $this->redirect(['site/login']);
        }

        $model = Cliente::findOne(['idCliente' => $idCliente]);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            $usuario = Usuario::findOne(['id' => $model->usuario]);
            // UPDATE
            // Si se cambia el correo o el nombre del cliente, se la cambiamos también a la tabla usuario 
            $connection = Yii::$app->db;
            $connection->createCommand()->update('usuario', ['nombre' => $model->nombre, 'username' => $model->correo], ['id' => $usuario->id])->execute();

            return $this->redirect(['cuenta', 'idUsuario' => $model->usuario]);
        }

        return $this->render('actualizarcuenta', [
            'model' => $model,
        ]);
    }

    // Cancelar un pedido
    public function actionCancelarpedido($idPedido)
    {
        $pedido = Pedido::findOne(['idPedido' => $idPedido]);

        $producto = Producto::findOne(['idProducto' => $pedido->idProducto]);

        // Comparamos la fecha de envio con la fecha actual

views/layouts/_menuAdmin.php
<?php

use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;

echo Nav::widget([
    'options' => ['class' => 'navbar-nav'],
    'items' => [
        ['label' => 'Ofertas', 'url' => ['/site/ofertas']],
        ['label' => 'Productos', 'url' => ['/site/secciones']],
        ['label' => 'Administración', 'items' => [
            ['label' => 'Pedidos', 'url' => ['/pedido/index']],
            ['label' => 'Clientes', 'url' => ['/cliente/index']],
            ['label' => 'Productos', 'url' => ['/producto/index']],
            ['label' => 'Secciones', 'url' => ['/seccion/index']],
            ['label' => 'Usuarios', 'url' => ['/usuario/index']],
        ], 'style' => 'background-color:red;'],

        Yii::$app->user->isGuest
            ? ['label' => ' Iniciar sesión', 'url' => ['/site/login'], 'linkOptions' => ['class' => 'far fa-user-circle', 'style' => 'font-size:1.1em;position:relative;top:4px']]
            : '<li class="nav-item">'
            . Html::beginForm(['/site/logout'])
            . Html::submitButton(
                'Logout (' . Yii::$app->user->identity->nombre . ')',
                ['class' => 'nav-link btn btn-link logout']
            )
            . Html::endForm()
            . '</li>'
    ]
]);

views/layouts/_menuInvitado.php
<?php

use yii\bootstrap5\Nav;

echo Nav::widget([
    'options' => ['class' => 'navbar-nav'],
    'items' => [
        ['label' => 'Ofertas', 'url' => ['/site/ofertas']],
        ['label' => 'Productos', 'url' => ['/site/secciones']],
    ]
]);
echo Nav::widget([
    'options' => ['class' => 'navbar-nav ms-auto'],
    'items' => [
        ['label' => 'Registrarse', 'url' => ['/site/registro']],
        ['label' => ' Login ', 'url' => ['/site/login'], 'linkOptions' => ['class' => "fas fa-user", 'style' => 'position:relative;top:5px']],
    ]
]);

views/layouts/_menuUsuario.php
<?php

use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;


echo Nav::widget([
    'options' => ['class' => 'navbar-nav '],
    'items' => [
        ['label' => 'Ofertas', 'url' => ['/site/ofertas']],
        ['label' => 'Productos', 'url' => ['/site/secciones']],
    ]
]);
echo Nav::widget([
    'options' => ['class' => 'navbar-nav ms-auto'],
    'items' => [
        ['label' => ' Mis pedidos', 'url' => ['/site/verpedidos', 'idCliente' => Yii::$app->user->identity->id], 'linkOptions' => ['class' => 'fas fa-shopping-cart', 'style' => 'position:relative;top:4px']],
        ['label' => 'Mi cuenta  ', 'url' => ['/site/cuenta', 'idUsuario' => Yii::$app->user->identity->id]],

        Yii::$app->user->isGuest
            ? ['label' => ' Iniciar sesión', 'url' => ['/site/login'], 'linkOptions' => ['class' => 'far fa-user-circle', 'style' => 'font-size:1.1em;position:relative;top:4px']]
            : '<li class="nav-item">'
            . Html::beginForm(['/site/logout'])
            . Html::submitButton(
                'Logout (' . Yii::$app->user->identity->nombre . ')',
                ['class' => 'nav-link btn btn-link logout']
            )
            . Html::endForm()
            . '</li>'
    ]
]);

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">

<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>

<body class="d-flex flex-column h-100">
    <?php $this->beginBody() ?>

    <header id="header">
        <?php
        NavBar::begin([
            'brandLabel' => Yii::$app->name,
            'brandUrl' => Yii::$app->homeUrl,
            'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
        ]);

        if (Yii::$app->user->isGuest) {
            echo $this->render('_menuInvitado');
        } elseif (Yii::$app->user->identity->isAdmin) {
            echo $this->render('_menuAdmin');
        } else {
            echo $this->render('_menuUsuario');
        }


        NavBar::end();
        ?>
    </header>

    <main id="main" class="flex-shrink-0" role="main">
        <div class="container">
            <?php if (!empty($this->params['breadcrumbs'])) : ?>
                <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
            <?php endif ?>
            <?= Alert::widget() ?>
            <?= $content ?>
        </div>
    </main>

    <footer id="footer" class="mt-auto py-3 bg-light">
        <div class="container">
            <div class="row text-muted">
                <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
                <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
            </div>
        </div>
    </footer>

    <?php $this->endBody() ?>
</body>

</html>
<?php $this->endPage() ?>